#include <cstdlib>
#include <iostream>
#include <fstream>
#include <sstream>
#include <string>

#include "utils.h"

vector<float> seq( float a, float b, int length )
{
    vector<float> result(length);
    float l = (b-a)/(float)(length-1);
    for(int i = 0; i < length; ++i)
    {
        result[i] = i*l;
    }
    return result;
}

int factorial( int n )
{
	int result = 1;
	for( int i = 0; i < n; ++i)
	{
		result = result * (n-i);
	}
	return result;
}

void getControlPoints( const char * filename, vector<Vector2d>& points)
{
	int i = 0;
	char buffer[200];
	stringstream ss;
	ifstream file(filename);

	if(file.is_open())
	{
		while( file.getline(buffer, 100) )
		{
			ss << buffer;
			Vector2d tmp;
			for( int j = 0; j < 2; ++j )
			{
				ss.getline(buffer, 100, ' '); //parsing
				if(j == 0){tmp[0] = atof(buffer);}
				if(j == 1){tmp[1] = atof(buffer);}
				ss << ""; //next parsing
				ss.clear();
			}
			points.push_back(tmp);
		}
		++i;
	}
	file.close();
}

void write(const char* filename, vector<Vector2d>& points)
{
	ofstream outputFile;
	outputFile.open(filename);
	outputFile.precision(8);
	int size = points.size();
	for(int i = 0; i < size; ++i)
	{
		outputFile << points[i][0] << " " << points[i][1] << "\n";
	}
	outputFile.close();
}
